package com.logicbig.example;

import com.logicbig.example.app.OrderClient;
import org.springframework.context.annotation.*;
import org.springframework.core.env.ConfigurableEnvironment;

@Configuration
@ComponentScan({"com.logicbig.example.service", "com.logicbig.example.app"})
@Import(DataAccessConfig.class)
public class AppConfig {

    public static void main(String[] args) {
        runApp("local");
        System.out.println("---------");
        runApp( "dev");
    }

    private static void runApp(String profileName) {
        AnnotationConfigApplicationContext context =
                new AnnotationConfigApplicationContext();
        ConfigurableEnvironment env = context.getEnvironment();
        env.setActiveProfiles(profileName);
        context.register(AppConfig.class);
        context.refresh();

        OrderClient orderClient = context.getBean(OrderClient.class);
        orderClient.placeOrder("customer-1");
    }
}